import torch
from models.model import GLPDepth
import sys
from collections import OrderedDict
import iio
import matplotlib.pyplot as plt
import cv2

device = 'cpu'
model = GLPDepth(max_depth=10., is_train=False).to(device)
model_weight = torch.load(sys.argv[1], map_location='cpu')
if 'module' in next(iter(model_weight.items()))[0]:
    model_weight = OrderedDict((k[7:], v) for k, v in model_weight.items())
model.load_state_dict(model_weight)
model.eval()

im = iio.read(sys.argv[2])/255.
shape = im.shape
im = cv2.resize(im, (512,512))
im = torch.tensor(im).permute(2,0,1).unsqueeze(0)

with torch.no_grad():
    pred = model(im)

pred_d = pred['pred_d']
pred_d = pred_d[0,0,...].numpy()
pred_d = cv2.resize(pred_d, shape[:2][::-1])
iio.write(sys.argv[3]+'.tif', pred_d)
plt.imsave(sys.argv[3]+'.png', -pred_d, cmap='inferno')
